use regex::Regex;

fn main() {
    let input = include_str!("../../input.txt").lines();
    let regex = Regex::new("#+").unwrap();
    let mut result = 0;

    for line in input {
        let mut parts = line.split(" ");
        let field = parts.next().unwrap().split("").filter(|i| i.len() > 0).collect::<Vec<&str>>();
        let instructions = parts.next().unwrap().split(",").map(|i| i.parse::<i32>().unwrap()).collect::<Vec<i32>>();

        println!("{:?} {:?}", field, instructions);

        let unknown_count = field.iter().filter(|i| i == &&"?").count();
        for i in 0..i32::pow(2, unknown_count as u32) {
            let mut current_field = field.clone();
            let mut pos = 0;

            for (j, spring) in current_field.clone().iter().enumerate() {
                if spring == &"?" {
                    current_field[j] = if i & 1 << pos > 0 { "#" } else { "." };
                    pos += 1;
                }
            }

            let field_str = current_field.join("");
            let pairs = regex
            .find_iter(field_str.as_str())
            .map(|m| m.as_str().len() as i32)
            .collect::<Vec<i32>>();
        
            if pairs.len() == instructions.len() && pairs.iter().zip(&instructions).filter(|(a, b)| a != b).count() == 0 {
                result += 1;
            }
        }
    }

    println!("Result: {result}");
}
