fn main() {
    let input = include_str!("../../input.txt").trim();
    let mut result = 0;

    'balls: for section in input.split("\n\n") {
        let grid: Vec<Vec<bool>> = section
            .lines()
            .map(|line| line.chars().map(|c| c == '#').collect::<Vec<bool>>())
            .collect::<Vec<Vec<bool>>>();

        // Vertical
        for mut i in 0..(grid.len() - 1) as i32 {
            let res_val = (i + 1) * 100;
            let mut j = (i + 1) as i32;

            'nuts: loop {
                if i < 0 || j >= grid.len() as i32 {
                    result += res_val;
                    continue 'balls;
                }

                for k in 0..grid[i as usize].len() {
                    if grid[i as usize][k] != grid[j as usize][k] {
                        break 'nuts;
                    }
                }

                i -= 1;
                j += 1;
            }
        }

        // Horizontal
        for mut i in 0..(grid[0].len() - 1) as i32 {
            let res_val = i + 1;
            let mut j = (i + 1) as i32;

            'nuts: loop {
                if i < 0 || j >= grid[0].len() as i32 {
                    result += res_val;
                    continue 'balls;
                }

                for k in 0..grid.len() {
                    if grid[k][i as usize] != grid[k][j as usize] {
                        break 'nuts;
                    }
                }

                i -= 1;
                j += 1;
            }
        }
    }

    println!("Result: {result}");
}
