const MAX_RED: i32 = 12;
const MAX_GREEN: i32 = 13;
const MAX_BLUE: i32 = 14;

fn main() {
    let input = include_str!("../../input.txt");
    let mut result = 0;

    'main: for line in input.lines() {
        let parts: Vec<&str> = line.split(": ").collect();

        // Could just count up every iteration instead of wasting time with parsing text but whatever
        let gameid: i32 = parts
            .first()
            .unwrap()
            .replace("Game ", "")
            .parse()
            .unwrap();

        for draw in parts.last().unwrap().split(&[',', ';'][..]) {
            let segments: Vec<&str> = draw.trim().split(" ").collect();
            let count: i32 = segments.first().unwrap().parse().unwrap();
            let max = match *segments.last().unwrap() {
                "red" => MAX_RED,
                "green" => MAX_GREEN,
                "blue" => MAX_BLUE,
                _ => panic!(),
            };

            if count > max {
                continue 'main;
            }
        }

        result += gameid;
    }

    println!("Result: {}", result);
}
