fn dec_if_pos(input: usize) -> usize {
    if input > 0 {
        return input - 1;
    } else {
        return input;
    }
}

fn inc_if_lt(input: usize, max: usize) -> usize {
    if input < max {
        return input + 1;
    } else {
        return  input;
    }
}

fn main() {
    let input = include_str!("../../input.txt").trim_end();
    let mut field: Vec<Vec<char>> = Vec::new();
    let mut checked: Vec<Vec<bool>> = Vec::new();
    let mut sum = 0;

    // Convert input into a 2d array
    for line in input.lines() {
        field.push(Vec::from(line.chars().collect::<Vec<char>>()));
        checked.push(Vec::from(line.chars().map(|_| false).collect::<Vec<bool>>()));
    }

    // Determine which numbers are adjacent to a special character
    for i in 0..field.len() {
        for j in 0..field[i].len() {

            if checked[i][j] || !field[i][j].is_numeric() {
                continue;
            }

            'surrounding: for offset_i in dec_if_pos(i)..=inc_if_lt(i, field.len() - 1) {
                for offset_j in dec_if_pos(j)..=inc_if_lt(j, field[offset_i].len() - 1) {
                    if !field[offset_i][offset_j].is_numeric() && field[offset_i][offset_j] != '.' {

                        // Traverse right until we hit a non-digit and mark all of them as checked.
                        let mut result: String = String::new();
                        let mut position = j;
                        while position < field.len() && field[i][position].is_numeric() {
                            result.push(field[i][position]);
                            checked[i][position] = true;
                            position += 1;
                        }

                        // Now to the left. (i hate usize)
                        if j > 0 {
                            position = j - 1;
                            while field[i][position].is_numeric() {
                                result.insert(0, field[i][position]);
                                checked[i][position] = true;

                                if position == 0 {
                                    break;
                                }
                                position -= 1;
                            }
                        }

                        sum += result.parse::<i32>().unwrap();
                        break 'surrounding;

                    }
                }
            }

        }
    }

    println!("Result: {}", sum);
}
