fn dec_if_pos(input: usize) -> usize {
    if input > 0 {
        return input - 1;
    } else {
        return input;
    }
}

fn inc_if_lt(input: usize, max: usize) -> usize {
    if input < max {
        return input + 1;
    } else {
        return  input;
    }
}

fn main() {
    let input = include_str!("../../input.txt").trim_end();
    let mut field: Vec<Vec<char>> = Vec::new();
    let mut sum = 0;

    // Convert input into a 2d array
    for line in input.lines() {
        field.push(Vec::from(line.chars().collect::<Vec<char>>()));
    }

    // Determine which numbers are adjacent to a special character
    for i in 0..field.len() {
        for j in 0..field[i].len() {

            if field[i][j] != '*' {
                continue;
            }

            let mut found: Vec<i32> = Vec::new();
            let mut checked: Vec<Vec<bool>> = Vec::new();

            for i in 0..field.len() {
                checked.push(field[i].iter().map(|_| false).collect());
            }

            for offset_i in dec_if_pos(i)..=inc_if_lt(i, field.len() - 1) {
                for offset_j in dec_if_pos(j)..=inc_if_lt(j, field[offset_i].len() - 1) {
                    if field[offset_i][offset_j].is_numeric() && !checked[offset_i][offset_j] {

                        // Traverse right until we hit a non-digit and mark all of them as checked.
                        let mut result: String = String::new();
                        let mut position = offset_j;
                        while position < field.len() && field[offset_i][position].is_numeric() {
                            result.push(field[offset_i][position]);
                            checked[offset_i][position] = true;
                            position += 1;
                        }

                        // Now to the left.
                        if offset_j > 0 {
                            position = offset_j - 1;
                            while field[offset_i][position].is_numeric() {
                                result.insert(0, field[offset_i][position]);
                                checked[offset_i][position] = true;

                                if position == 0 {
                                    break;
                                }
                                position -= 1;
                            }
                        }

                        found.push(result.parse::<i32>().unwrap());

                    }
                }
            }

            if found.len() == 2 {
                sum += found[0] * found[1];
            }

        }
    }

    println!("Result: {}", sum);
}
