fn main() {
    let input = include_str!("../../input.txt").trim_end();
    let mut segments: Vec<&str> = input.split("\n\n").collect::<Vec<&str>>();
    let mut numbers: Vec<i64> = segments
        .remove(0)
        .replace("seeds: ", "")
        .split(" ")
        .map(|num| num.parse::<i64>().unwrap())
        .collect();

    for segment in segments {
        let mut new_numbers: Vec<i64> = Vec::new();
        let mut lines = segment.trim().lines();
        lines.next(); // Remove first line

        for line in lines {
            let values = line
                .split(" ")
                .map(|num| num.parse::<i64>().unwrap())
                .collect::<Vec<i64>>();

            let dest_start = values[0];
            let source_start = values[1];
            let range_len = values[2];

            let mut to_delete: Vec<usize> = Vec::new();
            for i in 0..numbers.len() {
                let num = numbers[i];

                if num >= source_start && num < source_start + range_len {
                    new_numbers.push(dest_start + (num - source_start));
                    to_delete.push(i);
                }
            }

            to_delete.sort_by(|a, b| b.cmp(a));
            for i in to_delete {
                numbers.remove(i);
            }
        }

        for num in new_numbers {
            numbers.push(num);
        }
    }

    numbers.sort();
    println!("Result: {}", numbers.first().unwrap());
}
