use std::collections::HashMap;

use regex::Regex;

fn main() {
    let regex = Regex::new("^(?<key>\\w{3}) = \\((?<left>\\w{3}), (?<right>\\w{3})\\)").unwrap();
    let mut input = include_str!("../../input.txt").lines();
    let mut nodes: HashMap<&str, [&str; 2]> = HashMap::new();
    let instructions = input.next().unwrap();
    input.next(); // Skip empty line

    for line in input {
        let captures = regex.captures(line).unwrap();
        nodes.insert(
            &captures.name("key").unwrap().as_str(),
            [
                &captures.name("left").unwrap().as_str(),
                &captures.name("right").unwrap().as_str(),
            ]
        );
    }
    
    let mut current_node = "AAA";
    let mut moves = 0;

    while current_node != "ZZZ" {
        let instructions_pos = moves % instructions.len();
        let instruction = instructions.chars().nth(instructions_pos).unwrap();
        current_node = nodes[current_node][if instruction == 'L' { 0 } else { 1 }];
        moves += 1;
    }

    println!("Result: {moves}");
}
