use std::collections::HashMap;
use regex::Regex;

// i stole both of these functions from some weird programming blog

fn lcm(first: i64, second: i64) -> i64 {
    first * second / gcd(first, second)
}

fn gcd(first: i64, second: i64) -> i64 {
    let mut max = first;
    let mut min = second;
    if min > max {
        let val = max;
        max = min;
        min = val;
    }

    loop {
        let res = max % min;
        if res == 0 {
            return min;
        }

        max = min;
        min = res;
    }
}

fn main() {
    let regex = Regex::new("^(?<key>\\w{3}) = \\((?<left>\\w{3}), (?<right>\\w{3})\\)").unwrap();
    let mut input = include_str!("../../input.txt").lines();
    let mut nodes: HashMap<&str, [&str; 2]> = HashMap::new();
    let instructions = input.next().unwrap();
    input.next(); // Skip empty line

    for line in input {
        let captures = regex.captures(line).unwrap();
        nodes.insert(
            &captures.name("key").unwrap().as_str(),
            [
                &captures.name("left").unwrap().as_str(),
                &captures.name("right").unwrap().as_str(),
            ]
        );
    }
    
    let mut current_nodes: Vec<&str> = nodes
        .clone()
        .into_iter()
        .map(|node| node.0)
        .filter(|node| node.ends_with('A'))
        .collect();

    let mut move_counts: Vec<i32> = Vec::new();

    for i in 0..current_nodes.len() {
        let mut moves = 0;
        while !current_nodes[i].ends_with("Z") {
            let instructions_pos = moves % instructions.len();
            let instruction = instructions.chars().nth(instructions_pos).unwrap();
            current_nodes[i] = nodes[current_nodes[i]][if instruction == 'L' { 0 } else { 1 }];
            moves += 1;
        }
        move_counts.push(moves as i32);
    }

    let mut result: i64 = move_counts.remove(0) as i64;
    for m in move_counts {
        result = lcm(result, m.into());
    }

    println!("Result: {result}");
}
